
; IMPLEMENTACIJA SERPENT ENKRIPCIJSKOG ALGORITMA
; nasm verzija: http://fp.gladman.plus.com/cryptography_technology/serpent/serpent.asm

; POSTAVLJANJE KLJUA

; push duzina           ; duzina kljua (uvijek 256)
; push offset kljuc     ; klju
; call _serpent_set_key

; ENKRIPCIJA

; push offset izlaz     ; gdje pohraniti rezultat
; push offset ulaz      ; to enkriptirati
; call _serpent_encrypt

; DEKRIPCIJA

; push offset izlaz     ; gdje pohraniti rezultat
; push offset ulaz      ; to dekriptirati
; call _serpent_decrypt

; bF! (marios_crk@yahoo.co.uk) :: 21.09.2003. [nedjelja]

.586
.XMM

; +++++++++++++++++++++++++++++++++++++++ MAKRO NAREDBE

sb0     macro   @1,@2,@3,@4,@5
        pxor    @4,@1   
        movq    @5,@2   
        pand    @2,@4   
        pxor    @5,@3   
        pxor    @2,@1   
        por     @1,@4   
        pxor    @1,@5   
        pxor    @5,@4   
        pxor    @4,@3   
        por     @3,@2   
        pxor    @3,@5   
        pxor    @5,mm7  
        por     @5,@2   
        pxor    @2,@4   
        pxor    @2,@5   
        por     @4,@1   
        pxor    @2,@4   
        pxor    @5,@4   
endm

ib0     macro   @1,@2,@3,@4,@5
        pxor    @3,mm7  
        movq    @5,@2   
        por     @2,@1   
        pxor    @5,mm7  
        pxor    @2,@3   
        por     @3,@5   
        pxor    @2,@4   
        pxor    @1,@5   
        pxor    @3,@1   
        pand    @1,@4   
        pxor    @5,@1   
        por     @1,@2   
        pxor    @1,@3   
        pxor    @4,@5   
        pxor    @3,@2   
        pxor    @4,@1   
        pxor    @4,@2   
        pand    @3,@4   
        pxor    @5,@3   
endm

sb1     macro   @1,@2,@3,@4,@5
        pxor    @1,mm7  
        pxor    @3,mm7  
        movq    @5,@1   
        pand    @1,@2   
        pxor    @3,@1   
        por     @1,@4   
        pxor    @4,@3   
        pxor    @2,@1   
        pxor    @1,@5   
        por     @5,@2   
        pxor    @2,@4   
        por     @3,@1   
        pand    @3,@5   
        pxor    @1,@2   
        pand    @2,@3   
        pxor    @2,@1   
        pand    @1,@3   
        pxor    @1,@5   
endm

ib1     macro   @1,@2,@3,@4,@5
        movq    @5,@2   
        pxor    @2,@4   
        pand    @4,@2   
        pxor    @5,@3   
        pxor    @4,@1   
        por     @1,@2   
        pxor    @3,@4   
        pxor    @1,@5   
        por     @1,@3   
        pxor    @2,@4   
        pxor    @1,@2   
        por     @2,@4   
        pxor    @2,@1   
        pxor    @5,mm7  
        pxor    @5,@2   
        por     @2,@1   
        pxor    @2,@1   
        por     @2,@5   
        pxor    @4,@2   
endm

sb2     macro   @1,@2,@3,@4,@5
        movq    @5,@1   
        pand    @1,@3   
        pxor    @1,@4   
        pxor    @3,@2   
        pxor    @3,@1   
        por     @4,@5   
        pxor    @4,@2   
        pxor    @5,@3   
        movq    @2,@4   
        por     @4,@5   
        pxor    @4,@1   
        pand    @1,@2   
        pxor    @5,@1   
        pxor    @2,@4   
        pxor    @2,@5   
        pxor    @5,mm7  
endm

ib2     macro   @1,@2,@3,@4,@5
        pxor    @3,@4   
        pxor    @4,@1   
        movq    @5,@4   
        pand    @4,@3   
        pxor    @4,@2   
        por     @2,@3   
        pxor    @2,@5   
        pand    @5,@4   
        pxor    @3,@4   
        pand    @5,@1   
        pxor    @5,@3   
        pand    @3,@2   
        por     @3,@1   
        pxor    @4,mm7  
        pxor    @3,@4   
        pxor    @1,@4   
        pand    @1,@2   
        pxor    @4,@5   
        pxor    @4,@1   
endm

sb3     macro   @1,@2,@3,@4,@5
        movq    @5,@1   
        por     @1,@4   
        pxor    @4,@2   
        pand    @2,@5   
        pxor    @5,@3   
        pxor    @3,@4   
        pand    @4,@1   
        por     @5,@2   
        pxor    @4,@5   
        pxor    @1,@2   
        pand    @5,@1   
        pxor    @2,@4   
        pxor    @5,@3   
        por     @2,@1   
        pxor    @2,@3   
        pxor    @1,@4   
        movq    @3,@2   
        por     @2,@4   
        pxor    @2,@1   
endm

ib3     macro   @1,@2,@3,@4,@5
        movq    @5,@3   
        pxor    @3,@2   
        pand    @2,@3   
        pxor    @2,@1   
        pand    @1,@5   
        pxor    @5,@4   
        por     @4,@2   
        pxor    @4,@3   
        pxor    @1,@5   
        pxor    @3,@1   
        por     @1,@4   
        pxor    @1,@2   
        pxor    @5,@3   
        pand    @3,@4   
        por     @2,@4   
        pxor    @2,@3   
        pxor    @5,@1   
        pxor    @3,@5   
endm

sb4     macro   @1,@2,@3,@4,@5
        pxor    @2,@4   
        pxor    @4,mm7  
        pxor    @3,@4   
        pxor    @4,@1   
        movq    @5,@2   
        pand    @2,@4   
        pxor    @2,@3   
        pxor    @5,@4   
        pxor    @1,@5   
        pand    @3,@5   
        pxor    @3,@1   
        pand    @1,@2   
        pxor    @4,@1   
        por     @5,@2   
        pxor    @5,@1   
        por     @1,@4   
        pxor    @1,@3   
        pand    @3,@4   
        pxor    @1,mm7  
        pxor    @5,@3   
endm

ib4     macro   @1,@2,@3,@4,@5
        movq    @5,@3   
        pand    @3,@4   
        pxor    @3,@2   
        por     @2,@4   
        pand    @2,@1   
        pxor    @5,@3   
        pxor    @5,@2   
        pand    @2,@3   
        pxor    @1,mm7  
        pxor    @4,@5   
        pxor    @2,@4   
        pand    @4,@1   
        pxor    @4,@3   
        pxor    @1,@2   
        pand    @3,@1   
        pxor    @4,@1   
        pxor    @3,@5   
        por     @3,@4   
        pxor    @4,@1   
        pxor    @3,@2   
endm

sb5     macro   @1,@2,@3,@4,@5
        pxor    @1,@2   
        pxor    @2,@4   
        pxor    @4,mm7  
        movq    @5,@2   
        pand    @2,@1   
        pxor    @3,@4   
        pxor    @2,@3   
        por     @3,@5   
        pxor    @5,@4   
        pand    @4,@2   
        pxor    @4,@1   
        pxor    @5,@2   
        pxor    @5,@3   
        pxor    @3,@1   
        pand    @1,@4   
        pxor    @3,mm7  
        pxor    @1,@5   
        por     @5,@4   
        pxor    @3,@5   
endm

ib5     macro   @1,@2,@3,@4,@5
        pxor    @2,mm7  
        movq    @5,@4   
        pxor    @3,@2   
        por     @4,@1   
        pxor    @4,@3   
        por     @3,@2   
        pand    @3,@1   
        pxor    @5,@4   
        pxor    @3,@5   
        por     @5,@1   
        pxor    @5,@2   
        pand    @2,@3   
        pxor    @2,@4   
        pxor    @5,@3   
        pand    @4,@5   
        pxor    @5,@2   
        pxor    @4,@1   
        pxor    @4,@5   
        pxor    @5,mm7  
endm

sb6     macro   @1,@2,@3,@4,@5
        pxor    @3,mm7  
        movq    @5,@4   
        pand    @4,@1   
        pxor    @1,@5   
        pxor    @4,@3   
        por     @3,@5   
        pxor    @2,@4   
        pxor    @3,@1   
        por     @1,@2   
        pxor    @3,@2   
        pxor    @5,@1   
        por     @1,@4   
        pxor    @1,@3   
        pxor    @5,@4   
        pxor    @5,@1   
        pxor    @4,mm7  
        pand    @3,@5   
        pxor    @3,@4   
endm

ib6     macro   @1,@2,@3,@4,@5
        pxor    @1,@3   
        movq    @5,@3   
        pand    @3,@1   
        pxor    @5,@4   
        pxor    @3,mm7  
        pxor    @4,@2   
        pxor    @3,@4   
        por     @5,@1   
        pxor    @1,@3   
        pxor    @4,@5   
        pxor    @5,@2   
        pand    @2,@4   
        pxor    @2,@1   
        pxor    @1,@4   
        por     @1,@3   
        pxor    @4,@2   
        pxor    @5,@1   
endm

sb7     macro   @1,@2,@3,@4,@5
        movq    @5,@3   
        pand    @3,@2   
        pxor    @3,@4   
        pand    @4,@2   
        pxor    @5,@3   
        pxor    @3,@2   
        pxor    @2,@1   
        por     @1,@5   
        pxor    @1,@3   
        pxor    @4,@2   
        pxor    @3,@4   
        pand    @4,@1   
        pxor    @4,@5   
        pxor    @5,@3   
        pand    @3,@1   
        pxor    @5,mm7  
        pxor    @3,@5   
        pand    @5,@1   
        pxor    @2,@4   
        pxor    @5,@2   
endm

ib7     macro   @1,@2,@3,@4,@5
        movq    @5,@3   
        pxor    @3,@1   
        pand    @1,@4   
        pxor    @3,mm7  
        por     @5,@4   
        pxor    @4,@2   
        por     @2,@1   
        pxor    @1,@3   
        pand    @3,@5   
        pxor    @2,@3   
        pxor    @3,@1   
        por     @1,@3   
        pand    @4,@5   
        pxor    @1,@4   
        pxor    @5,@2   
        pxor    @4,@5   
        por     @5,@1   
        pxor    @4,@3
        pxor    @5,@3   
endm

f_key   macro   @1,@2,@3,@4
        movd    @1,[esi   ] 
        movd    @2,[esi+ 4] 
        movd    @3,[esi+ 8] 
        movd    @4,[esi+12] 
        movq    mm6,@1      
        psllq   mm6,32      
        por     @1,mm6      
        movq    mm6,@2      
        psllq   mm6,32      
        por     @2,mm6      
        movq    mm6,@3      
        psllq   mm6,32      
        por     @3,mm6      
        movq    mm6,@4      
        psllq   mm6,32      
        por     @4,mm6      
        add     esi,16      
endm

t_key   macro   @1,@2,@3,@4
        movq    [edi   ],@1 
        movq    [edi+ 8],@2 
        movq    [edi+16],@3 
        movq    [edi+24],@4 
        add     edi,32      
endm

rot     macro   @1,@2,@3,@4,@5
        movq    @5,@1   
        pslld   @1,13   
        psrld   @5,19   
        por     @1,@5   
        movq    @5,@3   
        pslld   @3,3    
        psrld   @5,29   
        por     @3,@5   
        movq    @5,@1   
        pslld   @5,3    
        pxor    @4,@3   
        pxor    @4,@5   
        pxor    @2,@1   
        pxor    @2,@3   
        movq    @5,@2   
        pslld   @2,1    
        psrld   @5,31   
        por     @2,@5   
        movq    @5,@4   
        pslld   @4,7    
        psrld   @5,25   
        por     @4,@5   
        movq    @5,@2   
        pxor    @1,@2   
        pxor    @1,@4   
        pslld   @5,7    
        pxor    @3,@4   
        pxor    @3,@5   
        movq    @5,@1   
        pslld   @1,5    
        psrld   @5,27   
        por     @1,@5   
        movq    @5,@3   
        pslld   @3,22   
        psrld   @5,10   
        por     @3,@5   
endm

irot    macro   @1,@2,@3,@4,@5
        movq    @5,@3   
        psrld   @3,22   
        pslld   @5,10   
        por     @3,@5   
        movq    @5,@1   
        psrld   @1,5    
        pslld   @5,27   
        por     @1,@5   
        movq    @5,@2   
        pslld   @5,7    
        pxor    @3,@4   
        pxor    @3,@5   
        pxor    @1,@2   
        pxor    @1,@4   
        movq    @5,@4   
        psrld   @4,7    
        pslld   @5,25   
        por     @4,@5   
        movq    @5,@2   
        psrld   @2,1    
        pslld   @5,31   
        por     @2,@5   
        movq    @5,@1   
        pslld   @5,3    
        pxor    @4,@3   
        pxor    @4,@5   
        pxor    @2,@1   
        pxor    @2,@3   
        movq    @5,@3   
        psrld   @3,3    
        pslld   @5,29   
        por     @3,@5   
        movq    @5,@1   
        psrld   @1,13   
        pslld   @5,19   
        por     @1,@5   
endm

k_loop  macro   @1,@2,@3,@4,@5
    f_key   @1,@2,@3,@4
    sb3     @1,@2,@3,@4,@5
    t_key   @2,@3,@4,@5 
    f_key   @1,@2,@3,@4
    sb2     @1,@2,@3,@4,@5
    t_key   @3,@4,@2,@5 
    f_key   @1,@2,@3,@4
    sb1     @1,@2,@3,@4,@5
    t_key   @3,@1,@4,@2 
    f_key   @1,@2,@3,@4
    sb0     @1,@2,@3,@4,@5
    t_key   @2,@5,@3,@1 
    f_key   @1,@2,@3,@4
    sb7     @1,@2,@3,@4,@5
    t_key   @3,@5,@4,@1
    f_key   @1,@2,@3,@4
    sb6     @1,@2,@3,@4,@5
    t_key   @1,@2,@5,@3
    f_key   @1,@2,@3,@4
    sb5     @1,@2,@3,@4,@5
    t_key   @2,@4,@1,@3
    f_key   @1,@2,@3,@4
    sb4     @1,@2,@3,@4,@5
    t_key   @2,@5,@1,@4
endm

f_xor   macro   @1,@2,@3,@4
        pxor    @1,[esi   ] 
        pxor    @2,[esi+ 8] 
        pxor    @3,[esi+16] 
        pxor    @4,[esi+24] 
        add     esi,32      
endm

f_loop  macro   @1,@2,@3,@4,@5
    f_xor   @1,@2,@3,@4
    sb0     @1,@2,@3,@4,@5
    rot     @2,@5,@3,@1,@4  
    f_xor   @2,@5,@3,@1 
    sb1     @2,@5,@3,@1,@4
    rot     @3,@2,@1,@5,@4  
    f_xor   @3,@2,@1,@5
    sb2     @3,@2,@1,@5,@4
    rot     @1,@5,@2,@4,@3  
    f_xor   @1,@5,@2,@4
    sb3     @1,@5,@2,@4,@3
    rot     @5,@2,@4,@3,@1  
    f_xor   @5,@2,@4,@3
    sb4     @5,@2,@4,@3,@1
    rot     @2,@1,@5,@3,@4  
    f_xor   @2,@1,@5,@3
    sb5     @2,@1,@5,@3,@4
    rot     @1,@3,@2,@5,@4  
    f_xor   @1,@3,@2,@5
    sb6     @1,@3,@2,@5,@4
    rot     @1,@3,@4,@2,@5  
    f_xor   @1,@3,@4,@2
    sb7     @1,@3,@4,@2,@5
endm 

i_xor   macro   @1,@2,@3,@4
        sub     esi,32      
        pxor    @1,[esi   ] 
        pxor    @2,[esi+ 8] 
        pxor    @3,[esi+16] 
        pxor    @4,[esi+24] 
endm

i_loop  macro   @1,@2,@3,@4,@5
    ib7     @1,@2,@3,@4,@5 
    i_xor   @4,@1,@2,@5 
    irot    @4,@1,@2,@5,@3 
    ib6     @4,@1,@2,@5,@3 
    i_xor   @1,@2,@3,@5 
    irot    @1,@2,@3,@5,@4 
    ib5     @1,@2,@3,@5,@4 
    i_xor   @2,@4,@5,@3 
    irot    @2,@4,@5,@3,@1 
    ib4     @2,@4,@5,@3,@1 
    i_xor   @2,@3,@5,@1 
    irot    @2,@3,@5,@1,@4 
    ib3     @2,@3,@5,@1,@4 
    i_xor   @1,@2,@5,@3 
    irot    @1,@2,@5,@3,@4 
    ib2     @1,@2,@5,@3,@4 
    i_xor   @2,@4,@5,@3 
    irot    @2,@4,@5,@3,@1 
    ib1     @2,@4,@5,@3,@1 
    i_xor   @1,@2,@3,@5 
    irot    @1,@2,@3,@5,@4 
    ib0     @1,@2,@3,@5,@4 
    i_xor   @1,@4,@2,@5
endm

; +++++++++++++++++++++++++++++++++++++++ POTPIS

.data
name_    DB          "serpent",0

.code
_serpent_name:
    lea     eax,[name_]
    ret

; +++++++++++++++++++++++++++++++++++++++ KONSTANTNE VARIJABLE

.data
in_key  = 20
key_len = 24

l_key   dd 140 dup(0)
m_key   dd 280 dup(0)

.code

; +++++++++++++++++++++++++++++++++++++++ POSTAVI KLJU

_serpent_set_key proc
        push    ebp
        push    ebx
        push    esi
        push    edi
        mov     edx,[esp + key_len]
        cmp     edx,256
        ja      l3
        lea     ebx,[l_key]
        mov     esi,[esp + in_key]
        xor     eax,eax
        mov     ecx,edx
        add     ecx,31
        sar     ecx,5
        je      short l0
        mov     edi,ebx
        mov     eax,ecx
        rep     movsd
l0:     cmp     edx,256
        je      short l1
        mov     ecx,8
        sub     ecx,eax
        xor     eax,eax
        rep     stosd
        mov     ecx,edx
        mov     edx,1
        sal     edx,cl
        sar     ecx,5
        mov     eax,edx
        dec     eax
        and     eax,[ebx+4*ecx]
        or      eax,edx
        mov     [ebx+4*ecx],eax
l1:     mov     esi,ebx
        mov     eax,9e3779b9h
        mov     ebx,eax
        xor     eax,[esi+ 8]
        xor     ebx,[esi+12]
        xor     eax,[esi+16]
        xor     ebx,[esi+20]
        xor     eax,[esi+24]
        xor     ebx,[esi+28]
        xor     ecx,ecx
        push    esi
l2:     mov     edx,[esi]
        xor     edx,ecx
        xor     edx,ebx
        ror     edx,21
        mov     [esi+32],edx
        xor     eax,[esi+8]
        xor     eax,edx
        add     esi,4
        inc     ecx
        mov     edx,[esi]
        xor     edx,ecx
        xor     edx,eax
        ror     edx,21
        mov     [esi+32],edx
        xor     ebx,[esi+8]
        xor     ebx,edx
        add     esi,4
        inc     ecx
        cmp     ecx,132
        jne     l2
        pop     esi
        add     esi,4*8
        lea     edi,[m_key + 8*8]
        xor     eax,eax
        dec     eax
        movd    mm7,eax
        movd    mm6,eax
        psllq   mm6,32
        por     mm7,mm6
    
        k_loop  mm0,mm1,mm2,mm3,mm4
        k_loop  mm0,mm1,mm2,mm3,mm4 
        k_loop  mm0,mm1,mm2,mm3,mm4 
        k_loop  mm0,mm1,mm2,mm3,mm4 
        f_key   mm0,mm1,mm2,mm3
        sb3     mm0,mm1,mm2,mm3,mm4 
        t_key   mm1,mm2,mm3,mm4
        emms
l3:     pop     edi
        pop     esi
        pop     ebx
        pop     ebp
        ret

_serpent_set_key endp

.data
in_blk  = 12
out_blk = 16

.code

; +++++++++++++++++++++++++++++++++++++++ ENKRIPCIJA

_serpent_encrypt    proc

        push        ebp
        push        esi
        mov         esi,[esp + in_blk]
        movq        mm0,[esi]
        movq        mm2,[esi+8]
        movq        mm4,[esi+16]
        movq        mm5,[esi+24]
        movq        mm1,mm0
        movq        mm3,mm2
        punpckldq   mm0,mm4
        punpckhdq   mm1,mm4
        punpckldq   mm2,mm5
        punpckhdq   mm3,mm5

        lea         esi,[m_key + 8*8]
        pxor        mm7,mm7
        pcmpeqd     mm7,mm7

        f_loop      mm0,mm1,mm2,mm3,mm4
        rot         mm3,mm4,mm1,mm0,mm2
        f_loop      mm3,mm4,mm1,mm0,mm2
        rot         mm0,mm2,mm4,mm3,mm1
        f_loop      mm0,mm2,mm4,mm3,mm1
        rot         mm3,mm1,mm2,mm0,mm4
        f_loop      mm3,mm1,mm2,mm0,mm4
        f_xor       mm0,mm4,mm1,mm3 
    
        mov         esi,[esp + out_blk]
        movq        mm2,mm0
        movq        mm5,mm1
        punpckldq   mm0,mm4
        punpckldq   mm1,mm3
        punpckhdq   mm4,mm2
        punpckhdq   mm3,mm5
        pshufw      mm4,mm4,4eh
        pshufw      mm3,mm3,4eh
        movq        [esi   ],mm0
        movq        [esi+ 8],mm1
        movq        [esi+16],mm4
        movq        [esi+24],mm3
        emms
        pop         esi
        pop         ebp
        ret

_serpent_encrypt    endp

; +++++++++++++++++++++++++++++++++++++++ DEKRIPCIJA

_serpent_decrypt    proc
        push        ebp
        push        esi
        mov         esi,[esp + in_blk]
        movq        mm0,[esi]
        movq        mm2,[esi+8]
        movq        mm4,[esi+16]
        movq        mm5,[esi+24]
        movq        mm1,mm0
        movq        mm3,mm2
        punpckldq   mm0,mm4
        punpckhdq   mm1,mm4
        punpckldq   mm2,mm5
        punpckhdq   mm3,mm5

        lea         esi,[m_key + 8*140]
        pxor        mm7,mm7
        pcmpeqd     mm7,mm7

        i_xor       mm0,mm1,mm2,mm3
        i_loop      mm0,mm1,mm2,mm3,mm4
        irot        mm0,mm3,mm1,mm4,mm2
        i_loop      mm0,mm3,mm1,mm4,mm2 
        irot        mm0,mm4,mm3,mm2,mm1
        i_loop      mm0,mm4,mm3,mm2,mm1
        irot        mm0,mm2,mm4,mm1,mm3
        i_loop      mm0,mm2,mm4,mm1,mm3 

        mov         esi,[esp + out_blk]
        movq        mm4,mm0
        movq        mm5,mm2
        punpckldq   mm0,mm1
        punpckldq   mm2,mm3
        punpckhdq   mm1,mm4
        punpckhdq   mm3,mm5
        pshufw      mm1,mm1,4eh
        pshufw      mm3,mm3,4eh
        movq        [esi   ],mm0
        movq        [esi+ 8],mm2
        movq        [esi+16],mm1
        movq        [esi+24],mm3
        emms
        pop         esi
        pop         ebp
        ret

_serpent_decrypt    endp